from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Directory, Boolean

Rgt_Viz_Heatmap_V0_1_0 = CommandToolBuilder(tool="rgt_viz_heatmap", base_command=["rgt-viz", "heatmap"], inputs=[ToolInput(tag="in_directory_name_output", input_type=Directory(optional=True), prefix="-o", doc=InputDocumentation(doc="The directory name for the output files. For example, project\nname. (default: None)")), ToolInput(tag="in_ga", input_type=Boolean(optional=True), prefix="-ga", doc=InputDocumentation(doc="Use genetic annotation data as input regions (e.g. TSS, TTS,\nexons and introns) instead of the BED files in the input\nmatrix. (default: False)")), ToolInput(tag="in_title_shown_heatmap", input_type=Boolean(optional=True), prefix="-t", doc=InputDocumentation(doc="The title shown on the top of the plot and also the folder\nname. (default: heatmap)")), ToolInput(tag="in_center", input_type=Boolean(optional=True), prefix="-center", doc=InputDocumentation(doc="Define the center to calculate coverage on the regions.\nOptions are: midpoint, bothends, upstream,\ndownstream.(Default:midpoint) The bothend mode will flap the\nright end region for calculation. (default: midpoint)")), ToolInput(tag="in_sort", input_type=Boolean(optional=True), prefix="-sort", doc=InputDocumentation(doc="Define the way to sort the signals.Default is no sorting at\nall, the signals arrange in the order of their position; '0'\nis sorting by the average ranking of all signals; '1' is\nsorting by the ranking of 1st column; '2' is 2nd and so on...\n(default: None)")), ToolInput(tag="in_col", input_type=Boolean(optional=True), prefix="-col", doc=InputDocumentation(doc="Group the data in columns by reads(needs 'factor' column),\nregions(needs 'factor' column), another name of column (for\nexample, 'cell')in the header of experimental matrix, or None.\n(default: regions)")), ToolInput(tag="in_color_data_readsneeds", input_type=Boolean(optional=True), prefix="-c", doc=InputDocumentation(doc="Color the data by reads(needs 'factor' column), regions(needs\n'factor' column), another name of column (for example,\n'cell')in the header of experimental matrix, or None.\n(default: reads)")), ToolInput(tag="in_row", input_type=Boolean(optional=True), prefix="-row", doc=InputDocumentation(doc="Group the data in rows by reads(needs 'factor' column),\nregions(needs 'factor' column), another name of column (for\nexample, 'cell')in the header of experimental matrix, or None.\n(default: None)")), ToolInput(tag="in_define_extend_length", input_type=Boolean(optional=True), prefix="-e", doc=InputDocumentation(doc="Define the extend length of interested region for plotting.\n(default: 2000)")), ToolInput(tag="in_rs", input_type=Boolean(optional=True), prefix="-rs", doc=InputDocumentation(doc="Define the readsize for calculating coverage. (default: 200)")), ToolInput(tag="in_ss", input_type=Boolean(optional=True), prefix="-ss", doc=InputDocumentation(doc="Define the stepsize for calculating coverage. (default: 50)")), ToolInput(tag="in_bs", input_type=Boolean(optional=True), prefix="-bs", doc=InputDocumentation(doc="Define the binsize for calculating coverage. (default: 100)")), ToolInput(tag="in_organism", input_type=Boolean(optional=True), prefix="-organism", doc=InputDocumentation(doc="Define the organism. (default: hg19)")), ToolInput(tag="in_color", input_type=Boolean(optional=True), prefix="-color", doc=InputDocumentation(doc="Define the specific colors with the given column 'color' in\nexperimental matrix. The color should be in the format of\nmatplotlib.colors. For example, 'r' for red, 'b' for blue, or\n'(100, 35, 138)' for RGB. (default: False)")), ToolInput(tag="in_log", input_type=Boolean(optional=True), prefix="-log", doc=InputDocumentation(doc="Set colorbar in log scale. (default: False)")), ToolInput(tag="in_mp", input_type=Boolean(optional=True), prefix="-mp", doc=InputDocumentation(doc="Perform multiprocessing for faster computation. (default:\nFalse)")), ToolInput(tag="in_show", input_type=Boolean(optional=True), prefix="-show", doc=InputDocumentation(doc="Show the figure in the screen. (default: False)")), ToolInput(tag="in_table", input_type=Boolean(optional=True), prefix="-table", doc=InputDocumentation(doc="Store the tables of the figure in text format. (default:\nFalse)\n"))], outputs=[ToolOutput(tag="out_directory_name_output", output_type=Directory(optional=True), selector=InputSelector(input_to_select="in_directory_name_output", type_hint=File()), doc=OutputDocumentation(doc="The directory name for the output files. For example, project\nname. (default: None)"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Rgt_Viz_Heatmap_V0_1_0().translate("wdl", allow_empty_container=True)

